<?php

namespace LaraBB\Category\UI\Web\Requests;

use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Http\RedirectResponse;

/**
 * Class Update
 * @package LaraBB\Category\UI\Web\Requests
 */
class Update extends FormRequest
{
    /**
     * @return bool
     */
    public function authorize(): bool
    {
        return true;
    }

    /**
     * @return array
     */
    public function rules(): array
    {
        return [
            'uuid'  => 'required|uuid|exists:categories,uuid',
            'title' => 'required|max:255',
            'slug'  => 'required|max:255'
        ];
    }

    /**
     * @return array
     */
    public function messages(): array
    {
        return [
            'uuid.required'  => 'Es wurde keine UUID übergeben.',
            'uuid.uuid'      => 'Die übergebene UUID ist ungültig.',
            'uuid.exists'    => 'Die zu bearbeitende Kategorie existiert nicht.',
            'title.required' => 'Bitte geben Sie eine Bezeichnung an!',
            'title.max'      => 'Die angegebene Bezeichnung ist zu lang (max. :max Zeichen).',
            'slug.required'  => 'Bitte geben Sie eine URL an!',
            'slug.max'       => 'Die angegebene URL ist zu lang (max. :max Zeichen).'
        ];
    }

    /**
     * @return RedirectResponse
     */
    public function success(): RedirectResponse
    {
        return redirect()->route('admin.forums')->with([
            'success'       => 'Die Kategorie wurde erfolgreich bearbeitet.',
            'alert-options' => 'aside'
        ]);
    }

    /**
     * @return RedirectResponse
     */
    public function failed(): RedirectResponse
    {
        return redirect()->route('admin.forums.category.edit', [$this->post('uuid')])->with([
            'error' => 'Die Kategorie konnte aufgrund einer technischen Störung nicht bearbeitet werden.',
        ]);
    }
}
